var PRX = {};

/**
 * <p>
 * ړ
 * PARALLEL: 
 * VERTICAL: 
 * BOTH: E
 * </p>
 */
PRX.DIRECTION = {
	'PARALLEL': 0,
	'VERTICAL': 1,
	'BOTH': 9
};

PRX.bgscrollAll2 = function(scrollValue) {
	PRX.bgscrollByDirection($('div.bg1'), PRX.DIRECTION.VERTICAL, parseInt(scrollValue / 4));
	PRX.bgscrollByDirection($('div.bg2'), PRX.DIRECTION.VERTICAL, parseInt(scrollValue / 2));
	var el4 = $('img.el4');
	PRX.scrollElByDirection(el4, PRX.DIRECTION.VERTICAL, scrollValue);
}

/**
 * <p>
 * ʓ̔wiSĈړ
 * </p>
 */
PRX.bgscrollAll = function() {
	PRX.bgscrollByDirection($('div.bg1'), PRX.DIRECTION.VERTICAL, 20);
	PRX.bgscrollByDirection($('div.bg2'), PRX.DIRECTION.VERTICAL, 5);
};

/**
 * <p>
 * ʓ̃GgSĈړ
 * </p>
 */
PRX.scrollMoveAll = function() {
	var el1 = $('img.el1');
	var move = 10;
	if (el1.offset().top + el1.height() < $(window).height() - move) {
		PRX.scrollElByDirection(el1, PRX.DIRECTION.BOTH, move);
	}
	var el2 = $('img.el2');
	if (el2.offset().top + el2.height() < $(window).height() - move) {
		PRX.scrollElByDirection(el2, PRX.DIRECTION.VERTICAL, move);
	}
	var el3 = $('img.el3');
	if (el3.offset().left + el2.width() < $(window).width() - move) {
		PRX.scrollElByDirection(el3, PRX.DIRECTION.PARALLEL, move);
	}
}

/**
 * <p>
 * w肳ꂽGĝwɎwlړB
 * l̏ꍇAiڏjEyяとֈړA
 * l̏ꍇAiڏjEyщֈړ
 * ܂ړʂقǈړx͑Ȃ
 * </p>
 * @param {jQuery} element ړΏۂ̃Gg
 * @param {PRX.DIRECTION} direction ړ
 * @param {numeric} move ړ
 */
PRX.scrollElByDirection = function(element, direction, move) {
	var moveX = 0;
	var moveY = 0;
	if (direction === PRX.DIRECTION.PARALLEL) {
		moveX = move;
	} else if (direction === PRX.DIRECTION.VERTICAL) {
		moveY = move;
	} else if (direction === PRX.DIRECTION.BOTH) {
		moveX = move;
		moveY = move;
	}
	PRX.scrollEl(element, moveX, moveY);
}

/**
 * <p>
 * w肳ꂽGg̈ʒuړB
 * </p>
 * @param {jQuery} element ړΏۂ̃Gg
 * @param {numeric} moveX ̈ړ
 * @param {numeric} moveY ̈ړ
 */
PRX.scrollEl = function(element, moveX, moveY) {
	var currentTop = element.offset().top;
	var currentLeft = element.offset().left;
	if (moveX) {
		currentLeft = currentLeft + moveX;
	}
	if (moveY) {
		currentTop = currentTop + moveY;
	}
	element.css('top', currentTop);
	element.css('left', currentLeft);
}

/**
 * <p>
 * w肳ꂽGg̔wiwɎwlړB
 * l̏ꍇAiڏjEyяとֈړA
 * l̏ꍇAiڏjEyщֈړ
 * ܂ړʂقǈړx͑Ȃ
 * </p>
 * @param {jQuery} element wiړΏۂ̃Gg
 * @param {PRX.DIRECTION} direction ړ
 * @param {numeric} move ړ
 */
PRX.bgscrollByDirection = function(element, direction, move) {
	var moveX = 0;
	var moveY = 0;
	if (direction === PRX.DIRECTION.PARALLEL) {
		moveX = move;
	} else if (direction === PRX.DIRECTION.VERTICAL) {
		moveY = move;
	} else if (direction === PRX.DIRECTION.BOTH) {
		moveX = move;
		moveY = move;
	}
	PRX.bgscroll(element, moveX, moveY);
};

/**
 * <p>
 * w肳ꂽGg̔wïʒuړB
 * </p>
 * @param {jQuery} element wiړΏۂ̃Gg
 * @param {numeric} moveX ̈ړ
 * @param {numeric} moveY ̈ړ
 */
PRX.bgscroll = function(element, moveX, moveY) {
	var currentX = 0;
	var currentY = 0;
	if (element.css('background-position-x')) {
		currentX = parseInt(element.css('background-position-x'));
	}
	if (element.css('background-position-y')) {
		currentY = parseInt(element.css('background-position-y'));
	}
	if (moveX) {
		currentX = currentX + moveX;
	}
	if (moveY) {
		currentY = currentY + moveY;
	}
	element.css('background-position-x', currentX);
	element.css('background-position-y', currentY);
};
